﻿function PercentColumn(x = 0, y = 0, w = 0, h = 0) {
	// Основной прямоугольник
	var rAll = new Rectangle(x, y, w, h);
	// Прямоугольник процентов
	var rPerc = new Rectangle();
	// Проценты поднимаются снизу вверх (false) или слева направо (true)
	var rotate = false;
	// Проценты статуса
	var percent = 0;
	// Цвет
	var color = '#000';

	// Геттеры и сеттеры для координат и размеров
	this.X = (val) => (val === undefined ? rAll.X() : rAll.X(val));
	this.Y = (val) => (val === undefined ? rAll.Y() : rAll.Y(val));
	this.W = (val) => (val === undefined ? rAll.W() : rAll.W(val));
	this.H = (val) => (val === undefined ? rAll.H() : rAll.H(val));

	// Установка процента от 0 до 100
	this.Percent = (val) => {
		if (val === undefined) return percent;
		percent = Math.max(0, Math.min(100, parseFloat(val) || 0));
	};
	
	//Установка цвета в формате #****** или #***
	this.Color = (val) => {
		if (val === undefined) return color;
		color = /^#([0-9a-f]{3}|[0-9a-f]{6})$/i.test(val) ? val : '#000000';
	};
	
	//Функция изменения начальной координаты и размеров прямоугольника
	this.RectParam = (_x, _y, _w, _h) => {
		rAll.RectParam(_x, _y, _w, _h);
	};
	
	//Функция изменения прямоугольника по другому прямоугольнику
	this.Rect = (val) => {
		if (val === undefined) return rAll;
		rAll.Rect(val);
	};
	
	//Изменение направления отрисовки процентов
	this.Rotate = (val) => {
		if (val === undefined) return rotate;
		rotate = typeof val === 'boolean' ? val : false;
	};
	//Перерасчитываем элементы
	function Rebuild() {
		var size = ((!rotate) ? rAll.H() : rAll.W()) * percent / 100;
		rPerc.RectParam(
			rAll.X(),
			rotate ? rAll.Y() : rAll.Y() + rAll.H() - size,
			rotate ? size : rAll.W(),
			rotate ? rAll.H() : size
		);
	}
	
	//Рисуем проценты
	this.Print = function (ctx) {
		Rebuild();
		ctx.fillStyle = color;
		ctx.strokeStyle = color;
		ctx.fillRect(rPerc.X(), rPerc.Y(), rPerc.W(), rPerc.H());
		ctx.strokeRect(rAll.X(), rAll.Y(), rAll.W(), rAll.H());
	};
	
	//Рисуем текст
	this.PrintText = function (ctx) {
		ctx.save();
		ctx.translate(rAll.X() + rAll.W() / 2, rAll.Y() + rAll.H() / 2);
		if (!rotate) ctx.rotate(3 * Math.PI / 2);
		ctx.fillStyle = '#888';
		ctx.textAlign = 'center';
		ctx.textBaseline = 'middle';
		
		if (!rotate)
			ctx.font = (rAll.W() - 10 < 0 ? 0 : rAll.W() - 10) + 'px Arial';
		else
			ctx.font = (rAll.H() - 10 < 0 ? 0 : rAll.H() - 10) + 'px Arial';
		ctx.fillText(Math.floor(percent * 100) / 100 + '%', 0, 0);
		ctx.restore();
	};
}
